
namespace eval ::arena::affects {
  variable affarray
  variable affects
  variable aid
  variable trgnick
  variable data
  variable time
  variable long

  ###       <id>,  <aid>
  ###    <data>,    <data>
  proc current {aid id {data "nodata"} {time "-"} {long "-"}} {
	 variable affarray

	 array set aff $affarray($id)

	 if { $data != "nodata" } {
		set aff($aid) ""
		lappend aff($aid) $data
		lappend aff($aid) $time
		lappend aff($aid) $long
		set affarray($id) [array get aff]
	 }
	 if { [info exist aff($aid)] } { return $aff($aid) }
	 return "0 - -"
  }                  
  
  ###   <aid>  <id>
  proc remove {aid id} {
	 current $aid $id 0
  }

  ###   
  proc val {aid id} {
	 set data [current $aid $id]
	 return [lindex $data 0]
  }  
  
  ###   
  proc exist {aid} {
	 variable affects
	 return [info exist affects($aid)]
  }    

  ###  
  proc list {} {
	 variable affects
	 return [array names affects]
  }  


  ###  
  ###   aid     - id 
  ###   id      -  
  ###   targ    -   
  ###   val     -  
  ###   prc     -    (0..1)
  ###   addtype -  
  proc add {aaid id targ val prc {addtype ""}} {
	 variable aid 
	 variable time 
	 variable long 
	 variable data

	 set aid $aaid
	 if { ![exist $aid] } {
		::error affect:add No affect exist ( $aid )
		return 0
	 }
	 set cdat [current $aid $targ]
	 set data [lindex $cdat 0]
	 set time [lindex $cdat 1]
	 set long [lindex $cdat 2]
	 if { "[info procs add:$aid]" == "" } {
		set data [expr $data + 1.0 * $val * $prc]
		set ret  1
	 } {
		set ret [add:$aid $aid $id $targ $val $prc $addtype]
	 }
	 if { $ret == "1" } {
		current $aid $targ $data $time $long
	 }
	 return $ret
  }


  ###  
  proc run {args} {
	 variable aid 
	 variable trgnick 
	 variable data 
	 variable time 
	 variable long

	 set state [join $args]
#	 putlog "Run affect state: !$state!"
	 foreach aid [list] {
		foreach astat [getstat time $aid] {
		  if { $astat == $state } {
			 foreach id [mc:game:livlist] {
				if { [lindex [set cdat [current $aid $id]] 0] != "0" } {
				  if { "[info procs run:$aid]" != "" } {
					 mc:round:rinit
					 set data [lindex $cdat 0]
					 set time [lindex $cdat 1]
					 set long [lindex $cdat 2]
					 set trgnick [ms:dfl [mc:getstat nick $id]]
					 set ret [run:$aid $aid $id $state]
					 if { $ret == "1" } {
						current $aid $id $data $time $long
					 }
				  }
				}
			 }
			 break
		  }
		}
	 }
  }

  #-----------------------------------------------

  proc init {} {
	 variable affarray 	 

	 foreach id [mc:game:livlist] {
		set affarray($id) ""
	 }
  }

  proc done {} {
	 variable affarray
	 unset affarray
  }


  proc say {txt} {
	 set d_result [mc:round:rdone]
	 if {$d_result != ""} { append txt " $d_result" }
	 ::mc:say "[cabg]$txt"
  }                                                                                
  #-----------------------------------------------

  proc load {} {
	 global mc 
	 global lstr
	 global errstr
	 variable affects 

	 if {[array exist affects]} { unset affects }
	 ::array_init affects
	 putlog "Loading affects..."
	 set fnl [glob -directory $::mc(file.affect) "*.affect"]

	 foreach lstr $fnl {
		if {[catch {uplevel #0 {source $lstr}} errstr]} {
		  putlog "Error while load affect ${lstr}: $errstr"
		} else {
		  array set afload [::affect:init]
		  rename affect:init ""		 
		  set aid $afload(code) 
		  foreach pid "add run" {
			 if {[info proc $pid:$aid] != ""} { rename $pid:$aid "" }
			 if {[info proc ::affect:$pid] != ""} {
				rename ::affect:$pid ::arena::affects::$pid:$aid
			 }			 
		  }		  
		  if { ![info exist afload(time)] } { set afload(time) "notime" }
		  if {[info exist affects($afload(code))]} {
			 putlog "Warning! Duplicate affect: $lstr"
		  } {
			 set affects($afload(code)) [array get afload]
		  }
		}
		unset afload
	 }
  }

  proc getstat {param id} {
	 variable affects

	 if { [info exist affects($id)] } {
		array set afrec $affects($id)
		if {[info exist afrec($param)]} {
		  return $afrec($param)
		}
	 }

	 ::error "affect:getstat" $param $id
	 return 0
  }

  proc inctime {} {
  }                                          

  proc ffrm {{add ""}} {
    variable aid
    if { $add != "" } { set add ".$add" }
    return [mcmsg f $aid $add]
  }
}
