


namespace eval ::arena::BotNet {
  
  variable pubfmt "\00314\[\00309%s\00314@\00303%s\00314\]\003 %s"
 
  
  proc init {} {	 
    rmbind "::arena::BotNet::*" {pubm bot}

	 ###   .
	 bind bot C ab_tryident     ::arena::BotNet::ident
	 ###   
	 bind bot C ab_tryreg		 ::arena::BotNet::reg
	 ###   .
	 bind bot C ab_privmsg      ::arena::BotNet::privmsg
	 ###  
	 bind bot C ab_part         ::arena::BotNet::uleave
	 ###    
	 bind bot C ab_pubmsg       ::arena::BotNet::pubmsg
	 ###  
	 bind bot C ab_join         ::arena::BotNet::ujoin
	 ###    !pub
	 bind bot C ab_saymsg       ::arena::BotNet::pubsay

	 ###   
	 bind pub - !pub				 ::arena::BotNet::chanpub  
   }
  
  proc parse {} {
	 upvar fb fb
	 upvar param param
	 upvar n  n
	 upvar id id
	 upvar uh uh

	 set param  [unbotnet $param]
    set n      [split [lindex $param 0] @]
    set uh     "$fb@[lindex $n 1]"
    set n		"[lindex $n 0]:$fb"
    set id [tolower $n]
    set param [ms:dfl [lrange $param 1 end]]
  }

  proc putbot {bn cm param} {
	 # TODO: check for bot up/downm, flags on bot
#	 putlog "<$bn>>> $cm $param"
	 if {[islinked $bn]} {
      ::putbot $bn [tobotnet [ms:fl "$cm $param"]] 	 
    }
  }

  proc putallbot {cm param {except "-"}} {
#		putlog "ex: $except"
    foreach bn [userlist b&C] {
		if {$bn != $except} {
  		  putbot $bn $cm $param
		}
	 }
  }

  proc msg {n txt} {
#	 putlog "send <$n> $txt"
	 if {[string index $n 0] == "#"} {
		say $txt
	 } {
	   putbot [nick2bot $n] ab_privmsg "$n $txt"	
	 }
  }

  proc notice {n txt} {
#	 putlog "notice <$n> $txt"
	 putbot [nick2bot $n] ab_notice "$n $txt"
  }

  proc say {txt} {
    putallbot ab_pubmsg $txt
  }

  proc ident {fb c param} {
	 parse
    mc:identify $n "botnet@botnet" "nohandle" "!ident $param"
#	 putbot $fb ab_tryident "$n $auth"
  }

  proc reg {fb c param} {
    parse
	 mc:reg $n "botnet@botnet" "nohandle" "!reg $param"
  }

  proc privmsg {fb c param} {
    parse

    if {![mc:userexists $id]} {
      putloglev m *0 "Rejected message from <$n>: $param \(No such user\)"
      return
    }
    set tl [split [mc:getstat nick $id] :]
    if {[string tolower [lindex [split $param] 0]] != "!ident"} {
      logtime 0
      putloglev m *0 "[hblk]\[[hblu][ms:dfl [lindex $tl 0]][hblk]\([blu][lindex $tl 1][hblk]\)\][cl] $param"	 
      logtime 1
    }
    foreach ee [binds "*mc:*"] {
      if { [lindex $ee 1] != "-|-" } continue
   
      if { [lindex $ee 0] == "msgm" && [string match -nocase [lindex $ee 2] [stripspec $param]] } {
        eval "[lindex $ee 4] \"[stripspec [ms:dfl $n]]\" {$uh} {nh} {[stripspec $param]}"
      } elseif { [lindex $ee 0] == "msg" } {
		  set cm [join [lindex [split $param] 0]]
        if {$cm == [lindex $ee 2]} {
			 eval "[lindex $ee 4] \"[stripspec [ms:dfl $n]]\" {$uh} {nh} {[stripspec [join [lrange [split $param] 1 end]]]}"
		  }
		}
	 }     	 
  }
  
  proc pubmsg {fb c param} {
    global mc	 
	 parse
	 
	 set mparam "$mc(chan) $param"

#	 putlog "PUB! $n ! $param"
	 set tl [split [mc:getstat nick $n] :]
    logtime 0	 
    putloglev m *0 "[hblk]\[[hblu][ms:dfl [lindex $tl 0]][hblk]\([blu][lindex $tl 1][hblk]\)\]\([cl]pub[hblk]\)[cl] $param"	 	 
    logtime 1
    foreach ee [binds "*mc:*"] {
      if { [lindex $ee 0] != "pub" && [lindex $ee 0] != "pubm" } continue
      if { [lindex $ee 1] != "-|-" } continue
   
      if { [string match -nocase [lindex $ee 2] [stripspec $mparam]] } {
        eval "[lindex $ee 4] \"[stripspec [ms:dfl $n]]\" {$uh} {nh} $mc(chan) {[stripspec $param]}"
#        putlog "[lindex $ee 4] \"[stripspec [ms:dfl $n]]\" {$uh} {nh} $mc(chan) {[stripspec $param]}" 	 
      }
	 }
  }

  proc uleave {fb c param} {
	 parse
    mc:r_leave $n 1
  }
  
  proc ujoin {fb c param} {
	 parse
    mc:r_join $n
  }
  
  proc pushmode {m p} {
    if { $m == "-m" || $m == "+m" } {
	   putallbot ab_pushmode "$m"
    } elseif { ($m == "-v" || $m == "+v") && [isbotnet $p] } {	 
	   putbot [nick2bot $p] ab_pushmode "$m $p"
    }		 
  } 

  proc qpushmode {m p} {
    if { $m == "-m" || $m == "+m" } {
	   putallbot ab_qpushmode "$m"
    } elseif { ($m == "-v" || $m == "+v") && [isbotnet $p] } {	 
	   putbot [nick2bot $p] ab_qpushmode "$m $p"
    }		 
  }  
  
  proc nick2bot {n} {
	 return [lindex [split $n :] 1]
  }

  proc isbotnet {n} {
	 if {[string first ":" $n] == -1} { return 0 } { return 1 }
  }


  proc pubsay {fb c param} {
	 global mc
	 variable pubfmt
	 parse

	 set str [format $pubfmt [ms:dfl [lindex [split $n :] 0]] $fb $param]
    putallbot ab_pubmsg $str $fb
	 putserv "PRIVMSG $mc(chan) :$str"
#    mc:say $str
  }  

  proc chanpub {n uh h c t} {
	 variable pubfmt
	 set str [format $pubfmt $n main $t]
    putallbot ab_pubmsg $str
  }
}
